package com.dfo.renderkit;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.faces.component.UIComponent;
import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import javax.faces.model.SelectItem;

import org.ajax4jsf.renderkit.HeaderResourcesRendererBase;
import org.ajax4jsf.util.InputUtils;
import org.ajax4jsf.util.SelectUtils;

import com.dfo.component.UIMultiSelectDropDown;

public abstract class MultiSelectDropDownRendererBase extends HeaderResourcesRendererBase{
	
	public void decode(FacesContext context, UIComponent component){
		System.out.println("Inside Decode Method");
		
		ExternalContext external = context.getExternalContext();
		Map requestParams = external.getRequestParameterMap();
		UIMultiSelectDropDown multiselectdropdown = (UIMultiSelectDropDown)component;
		String clientId = multiselectdropdown.getClientId(context);
		String submittedValue = (String)requestParams.get(clientId);
		System.out.println("SubmittedValue"+submittedValue);
		
		if(submittedValue !=null){
			System.out.println("Submitted Value is Not Null");
			multiselectdropdown.setSubmittedValue(submittedValue);
			System.out.println("submitted value"+multiselectdropdown.getSubmittedValue());
		}
		
		
	}
	
	public List<Object> encodeItems(FacesContext context, UIComponent component) throws IOException, IllegalArgumentException {
    	List <Object>values = new ArrayList<Object>();
		if (isAcceptableComponent(component)) {
			UIMultiSelectDropDown multiselectdropdown = (UIMultiSelectDropDown) component;
			//values.addAll(encodeSuggestionValues(context, multiselectdropdown));
			List<SelectItem> selectItems = SelectUtils.getSelectItems(context, component);
			for (SelectItem selectItem : selectItems) {
			    String convertedValue = getConvertedStringValue(context, component, selectItem.getValue());
				
				values.add(convertedValue);
				
			}
			System.out.println("Values"+values);
			encodeMultiSelect(context, multiselectdropdown,values);
		}
		return values;
    }
	
	 public void encodeMultiSelect(FacesContext context, UIComponent component,List<Object> values) throws IOException {
	    	ResponseWriter writer = context.getResponseWriter();
	    	if(writer != null) {
	    		writer.startElement("select", component);
	    		writer.writeAttribute("id", "s7", null);
	    		writer.writeAttribute("multiple", "multiple", null);
	    		encodeOptions(context,component,values);
	    		writer.endElement("select");
		    	/*writer.startElement(HTML.SPAN_ELEM, component);
		    	writer.writeAttribute(HTML.class_ATTRIBUTE, classes, null);
		    	writer.writeText(value, null);
		    	writer.endElement(HTML.SPAN_ELEM);*/
	    	}
	    }	
	 
	 public void encodeOptions(FacesContext context, UIComponent component, List<Object> values) throws IOException{
		 ResponseWriter writer = context.getResponseWriter();
		 Iterator<Object> iterator = null;

		 if(writer != null) {
			 
			 iterator = values.iterator();
		        while (iterator.hasNext()) {
		        	writer.startElement("option", component);
		            String element = (String) iterator.next();
		            System.out.println("Values from List Array"+element);
		            writer.write(element);
		            writer.endElement("option");
		        }
			 			 
		 }
	 }
	
	 protected String getConvertedStringValue(FacesContext context, UIComponent component, Object value) {
	    	return InputUtils.getConvertedStringValue(context, component, value);
	    }
	
	 protected boolean isAcceptableComponent(UIComponent component) {
	    	return component != null && this.getComponentClass().isAssignableFrom(component.getClass());
	    }
	
	protected String getValueAsString(FacesContext context,
			UIComponent component) throws IOException {

		UIMultiSelectDropDown multiselectdropdown = (UIMultiSelectDropDown) component;
		String valueString = (String) multiselectdropdown.getSubmittedValue();

		return valueString;
	}

}
